// Package connection provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/oapi-codegen/oapi-codegen/v2 version v2.4.1 DO NOT EDIT.
package connection

import (
	"time"

	"github.com/gofrs/uuid"
	"github.com/meshery/schemas/models/core"
	"github.com/meshery/schemas/models/v1beta1/environment"
)

// Defines values for ConnectionStatus.
const (
	Connected    ConnectionStatus = "connected"
	Deleted      ConnectionStatus = "deleted"
	Disconnected ConnectionStatus = "disconnected"
	Discovered   ConnectionStatus = "discovered"
	Ignored      ConnectionStatus = "ignored"
	Maintenance  ConnectionStatus = "maintenance"
	NotFound     ConnectionStatus = "not found"
	Registered   ConnectionStatus = "registered"
)

// Connection Meshery Connections are managed and unmanaged resources that either through discovery or manual entry are tracked by Meshery. Learn more at https://docs.meshery.io/concepts/logical/connections
type Connection struct {
	// ID ID
	ID uuid.UUID `db:"id" json:"id" yaml:"id"`

	// Name Connection Name
	Name string `db:"name" json:"name" yaml:"name"`

	// CredentialID Credential ID
	CredentialID *uuid.UUID `db:"credential_id" json:"credential_id,omitempty" yaml:"credential_id,omitempty"`

	// Type Connection Type
	Type string `db:"type" json:"type" yaml:"type"`

	// SubType Connection Subtype
	SubType string `db:"sub_type" json:"sub_type" yaml:"sub_type"`

	// Kind Connection Kind
	Kind     string   `db:"kind" json:"kind" yaml:"kind"`
	Metadata core.Map `db:"metadata" json:"metadata,omitempty" yaml:"metadata,omitempty"`

	// Status Connection Status
	Status ConnectionStatus `db:"status" json:"status" yaml:"status"`

	// UserID A Universally Unique Identifier used to uniquely identify entites in Meshery. The UUID core defintion is used across different schemas.
	UserID       *uuid.UUID                 `db:"user_id" json:"user_id,omitempty" yaml:"user_id,omitempty"`
	CreatedAt    time.Time                  `db:"created_at" json:"created_at,omitempty" yaml:"created_at,omitempty"`
	UpdatedAt    time.Time                  `db:"updated_at" json:"updated_at,omitempty" yaml:"updated_at,omitempty"`
	DeletedAt    core.NullTime              `db:"deleted_at" json:"deleted_at,omitempty" yaml:"deleted_at,omitempty"`
	Environments []*environment.Environment `db:"environments" gorm:"-" json:"environments,omitempty" yaml:"environments,omitempty"`
}

// ConnectionStatus Connection Status
type ConnectionStatus string

// ConnectionPage Represents a page of connections with a meta information about connections number
type ConnectionPage struct {
	Connections []*Connection `json:"connections" yaml:"connections"`

	// TotalCount Total number of connections on all pages
	TotalCount int `json:"total_count" yaml:"total_count"`

	// Page Page number
	Page int `json:"page" yaml:"page"`

	// PageSize Number of elements per page
	PageSize int `json:"page_size" yaml:"page_size"`
}
